-- Set a trial subscription (30 days), starting today, for every user that has at least one site (is site owner), but no subscription
INSERT INTO user_subscriptions(userId, plan, startDate, endDate, status) 
SELECT users.userId, 'STARTER_12', UNIX_TIMESTAMP()*1000, UNIX_TIMESTAMP()*1000 + 30 * 24 * 60 * 60 * 1000, 'TRIAL' 
FROM users JOIN site_user_role ON users.userId = site_user_role.userId LEFT JOIN user_subscriptions on users.userId = user_subscriptions.userId 
WHERE site_user_role.role = 'ROLE_SITE_OWNER' AND user_subscriptions.userId IS NULL;

-- Populate organizations from users + user_subscriptions
INSERT INTO `organizations`(`organizationId`, `name`, `ownerId`, `contactEmail`) SELECT 
CONCAT_WS('_', SUBSTRING_INDEX(users.email, '@', -1), users.userId), 
CONCAT_WS('_', SUBSTRING_INDEX(users.email, '@', -1), users.userId), users.userId, users.email from user_subscriptions, users WHERE user_subscriptions.userId = users.userId AND users.email != "userdeleted@userdeleted.com" AND users.email != "anonymous@anonymous.com";