-- WHF-107 Delete the 'visible' column because is not necessary anymore. We will determine from the 
-- deployment if a comment is shown or not.
 ALTER TABLE `comments` DROP COLUMN `visible`;
 
 -- WHF-101 Add a new column to the 'comments' table which contains the ID of the last user that edited the comment
ALTER TABLE `comments` ADD `lastEditUserId` int;

-- WHF-101 Add the Foreign Key constraint for the 'lastEditUserId'
ALTER TABLE `comments`
    ADD CONSTRAINT `lastEditUserId` FOREIGN KEY (`lastEditUserId`) REFERENCES `users` (`userId`);
	
UPDATE `comments` SET state='rejected' WHERE state='suspended'; 
ALTER TABLE `comments` MODIFY state enum('new','approved','rejected', 'deleted') NOT NULL;

-- WHF-224 Add a new column to the 'comments' for the topic title
 ALTER TABLE `comments` ADD `topicTitle` varchar(256);
 
ALTER TABLE comments CHANGE text content LONGTEXT NOT NULL;
ALTER TABLE comments CHANGE date creationDate TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP;