DELIMITER //
CREATE PROCEDURE `POPULATE_SITE_USER_ROLES`()
BEGIN
DECLARE n INT DEFAULT 0;
DECLARE m INT DEFAULT 0;
DECLARE i INT DEFAULT 0;
DECLARE j INT DEFAULT 0;
DECLARE owner INT DEFAULT 0;


SELECT COUNT(*) FROM sites INTO n;
SELECT COUNT(*) FROM users WHERE `level` = 'admin' OR `level` = 'moderator' INTO m;

SELECT n;

SET i = 0;
WHILE i<n DO
    SELECT i;
    SET @siteID := (SELECT siteId FROM sites LIMIT i,1);
    SET owner = 0;
    SET j = 0;
    SELECT m;
    WHILE j<m DO
        SET @userID := (SELECT `userId` FROM `users` WHERE `level` = 'admin' OR `level` = 'moderator' LIMIT j,1);

        SET @role := (SELECT `level` FROM `users` WHERE `level` = 'admin' OR `level` = 'moderator' LIMIT j,1);
        IF @role = 'admin' THEN
        	IF owner = 0 THEN
                INSERT INTO `site_user_role` (`siteId`, `userId`, `role`) VALUES (@siteID, @userID, 'ROLE_SITE_OWNER');
                SET owner = 1;
            ELSE
                INSERT INTO `site_user_role` (`siteId`, `userId`, `role`) VALUES (@siteID, @userID, 'ROLE_SITE_ADMIN');
            END IF;
        ELSE 
        	INSERT INTO `site_user_role` (`siteId`, `userId`, `role`) VALUES (@siteID, @userID, 'ROLE_SITE_MODERATOR');
        END IF;	
        SET j = j + 1;
    SELECT j;
    END WHILE;
SET i = i + 1;
END WHILE;
END//
DELIMITER ;

CREATE TABLE `site_user_role` (
  `userId` INT NOT NULL, 
  `siteId` INT NOT NULL, 
  `role` ENUM('ROLE_SITE_OWNER','ROLE_SITE_ADMIN', 'ROLE_SITE_MODERATOR', 'ROLE_SITE_TRUSTED_USER', 'ROLE_SITE_BANNED_USER') NOT NULL, 
  PRIMARY KEY (`userId`, `siteId`),
  FOREIGN KEY (`userId`) REFERENCES `users`(`userId`),
  FOREIGN KEY (`siteId`) REFERENCES `sites`(`siteId`)
  ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
  
 -- Populate table
CALL POPULATE_SITE_USER_ROLES();

-- Remove level column
ALTER TABLE `users` DROP COLUMN `level`;

 -- Delete the procedure
 DROP PROCEDURE IF EXISTS `POPULATE_SITE_USER_ROLES`;
