CREATE TABLE IF NOT EXISTS site_pages ( 
id int NOT NULL AUTO_INCREMENT, 
relPath varchar(512), 
wh_sourceRelPath varchar(512), 
title varchar(256), 
versionId int NOT NULL, 
PRIMARY KEY (id), 
FULLTEXT(title),
UNIQUE KEY path (relPath, versionId) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci AUTO_INCREMENT=1;

-- Add site_page_id column to comments (later will be foreign key)
  ALTER TABLE comments ADD site_page_id int NOT NULL; 

-- Add site_page_id column to page_views_record (later will be foreign key)
  ALTER TABLE page_views_record ADD site_page_id int NOT NULL; 

-- Populate site pages from the comments table
INSERT INTO `site_pages` (relPath, versionId) SELECT page, versionId FROM comments GROUP BY page, versionId;

UPDATE site_pages, comments SET site_pages.title=comments.pageTitle 
WHERE site_pages.relPath=comments.page AND site_pages.versionId=comments.versionId AND comments.pageTitle IS NOT NULL;

INSERT INTO `site_pages` (relPath, versionId) SELECT pagePath, versionId FROM page_views_record 
WHERE NOT EXISTS(
	SELECT * FROM site_pages WHERE site_pages.relPath = page_views_record.pagePath AND site_pages.versionId = page_views_record.versionId) 
GROUP BY page_views_record.pagePath, page_views_record.versionId;

UPDATE site_pages, page_views_record SET site_pages.title=page_views_record.pageTitle 
WHERE site_pages.relPath=page_views_record.pagePath AND 
site_pages.versionId=page_views_record.versionId AND page_views_record.pageTitle IS NOT NULL;

UPDATE comments, site_pages SET comments.site_page_id = site_pages.id WHERE comments.page=site_pages.relPath AND comments.versionId = site_pages.versionId;
UPDATE page_views_record, site_pages SET page_views_record.site_page_id = site_pages.id WHERE page_views_record.pagePath=site_pages.relPath AND page_views_record.versionId = site_pages.versionId;


  
-- Remove versionId foreign key constraint
  ALTER TABLE `comments` DROP FOREIGN KEY `deploymentId`;

-- Add foreign keys for comments and page_view_records 
  ALTER TABLE `comments`
    ADD CONSTRAINT `c_site_page_fkey` FOREIGN KEY (`site_page_id`) REFERENCES `site_pages` (`id`);
    
  ALTER TABLE `page_views_record`
    ADD CONSTRAINT `r_site_page_fkey` FOREIGN KEY (`site_page_id`) REFERENCES `site_pages` (`id`);
	
  ALTER TABLE `site_pages`
    ADD CONSTRAINT `v_site_page_fkey` FOREIGN KEY (`versionId`) REFERENCES `versions` (`versionId`);
    

-- Drop columns version, page, and pageTitle from comments
	ALTER TABLE `comments` 
		DROP COLUMN `page`, 
		DROP COLUMN `pageTitle`,
		DROP COLUMN `versionId`;
		
-- Drop columns pagePath and pageTitle from page_views_record
	ALTER TABLE `page_views_record` 
		DROP COLUMN `pagePath`, 
		DROP COLUMN `pageTitle`,
		DROP COLUMN `versionId`;
		