-- Insert the platform admin to an organization 

DELIMITER //
CREATE PROCEDURE `ADD_PLATFORM_ADMIN_ORGANIZATION`()
BEGIN
DECLARE n INT DEFAULT 0;
	
	SELECT COUNT(*) FROM organizations JOIN user_details on organizations.ownerId = user_details.userId WHERE user_details.role = 'ROLE_APPLICATION_ADMIN' INTO n;
    
    IF n = 0 THEN
		-- Add the organization for platform admin
		INSERT INTO `organizations`(`organizationId`, `name`,  ownerId, `contactEmail`) SELECT 
		CONCAT_WS('_', SUBSTRING_INDEX(users.email, '@', -1), users.userId), 
		CONCAT_WS('_', SUBSTRING_INDEX(users.email, '@', -1), users.userId), users.userId, users.email
		FROM users JOIN user_details ON user_details.userId = users.userId WHERE user_details.role = 'ROLE_APPLICATION_ADMIN';

		-- Set the platform admin default organization
		UPDATE `users` JOIN user_details on users.userId = user_details.userId JOIN organizations on users.userId = organizations.ownerId SET users.`organizationId`= organizations.id,
		`organizationRole`= 'ROLE_ORGANIZATION_OWNER' WHERE user_details.role = 'ROLE_APPLICATION_ADMIN';
	END IF;
	
END//
DELIMITER ;

CALL ADD_PLATFORM_ADMIN_ORGANIZATION();

DROP PROCEDURE IF EXISTS `ADD_PLATFORM_ADMIN_ORGANIZATION`;