CREATE OR REPLACE FUNCTION add_anonymous() RETURNS void AS $$
DECLARE rec RECORD;
DECLARE anon_user_id integer;
BEGIN
    FOR rec IN (SELECT id FROM organizations) LOOP
		IF NOT EXISTS (
			SELECT  *
			FROM    users 
			WHERE   organizationId = rec.id
			AND 	email = 'anonymous@anonymous.com'
		) THEN
			INSERT INTO users(email, name, organizationId, organizationRole) 
			VALUES ('anonymous@anonymous.com', 'Anonymous User', rec.id, 'ROLE_ORGANIZATION_MEMBER')
			RETURNING userid INTO anon_user_id;
			
			INSERT INTO user_details(userId, company, role) 
	        VALUES (anon_user_id, 'TODO', 'ROLE_ANONYMOUS');
 		END IF;
    END LOOP;
END;
$$ LANGUAGE PLPGSQL;

SELECT add_anonymous();

DROP FUNCTION IF EXISTS add_anonymous();